unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, QuickRpt, StdCtrls, Buttons, ExtCtrls, QRCtrls, DB,
  ADODB, EditN;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Panel1: TPanel;
    QuickRep1: TQuickRep;
    ADOConnection1: TADOConnection;
    ADOQuery1: TADOQuery;
    QRBand1: TQRBand;
    QRDBText1: TQRDBText;
    QRDBText2: TQRDBText;
    Panel2: TPanel;
    BitBtn1: TBitBtn;
    function StringToComponent(Value: string;parent:Tcomponent): TComponent;
    Function Getmem(var htm:string):boolean;
    Function GetBodyini:boolean;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure QuickRep1Preview(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Fname,Fhead,Fsize:Tstringlist;
  FromF: file;

implementation

uses preview,zlib;

{$R *.dfm}
function TForm1.StringToComponent(Value: string;parent:Tcomponent): TComponent;
var
  StrStream:TStringStream;
  BinStream: TMemoryStream;
begin
  StrStream := TStringStream.Create(Value);
  try
    BinStream := TMemoryStream.Create;
    try
      ObjectTextToBinary(StrStream, BinStream);
      BinStream.Seek(0, soFromBeginning);
      Result := BinStream.ReadComponent(parent);

    finally
      BinStream.Free;
    end;
  finally
    StrStream.Free;
  end;
end;


Function TForm1.Getmem(var htm:string):boolean;
var  Fmem,cp:Tmemorystream;
     cp1:TDeCompressionStream;
     i,NumRead,writetot:integer;
     Buf: array[1..2048] of Char;
     s,s1:string;
     f:textfile;
begin
   i:=fname.IndexOf(htm);
//   showmessage(htm+','+inttostr(i));
   htm:='';
   if not (i=-1) then
   begin
      cp:=TMemoryStream.Create;
      try
         seek(fromf,strtoint(Fhead.strings[i]));//head
         writetot:=0;
         repeat
            BlockRead(FromF, Buf, SizeOf(Buf), NumRead);
            if writetot+NumRead>strtoint(Fsize.strings[i]) then
               NumRead:=(strtoint(Fsize.strings[i])-writetot);
            writetot:=writetot+numread;
            cp.write(buf,numread);
         until (NumRead = 0) or (writetot>=strtoint(Fsize.strings[i]));
         cp1:=TDeCompressionStream.Create(cp);
         cp1.Position:=0;
         htm:='';
         repeat
            numRead:=cp1.Read(buf,sizeof(buf));
            if numread<sizeof(buf) then
            begin
               s:=buf;
               htm:=htm+copy(s,1,numread);
            end else
              htm:=htm+buf;
         until (numRead=0);
//         if pos('/',fname.Strings[i])>0 then
//            s1:=copy(fname.Strings[i],pos('/',fname.Strings[i])+1,length(fname.Strings[i])-pos('/',fname.Strings[i]))
//         else
//            s1:=fname.Strings[i];
//         assignfile(f,s1);
//         rewrite(f);
//         write(f,htm);
//         closefile(f);
         freeandnil(cp1);
         result:=true;
      except
         result:=false;
      end;
      freeandnil(cp);
   end else
      result:=false;
end;


Function TForm1.GetBodyini:boolean;
var  NumRead, NumWritten: Integer;
  Buf: array[1..2048] of Char;
  filerec:record
     filename:string[80];
     filesize:integer;
  end;
  writetot:integer;
  ok:boolean;
  Fmem:Tmemorystream;
  s:string;
begin
   try
      Fmem:=tmemorystream.Create;
      ok:=true;
      seek(fromf,filesize(fromf)-sizeof(filerec));   //ɮצW
      BlockRead(FromF,filerec,sizeof(filerec));
   //  caption:=filerec.filename+' '+inttostr(filerec.filesize);
      seek(fromf,filesize(fromf)-sizeof(filerec)-filerec.filesize);
      writetot:=0;
      repeat
         BlockRead(FromF, Buf, SizeOf(Buf), NumRead);
         if writetot+NumRead>filerec.filesize then
            NumRead:=(filerec.filesize-writetot);
         Fmem.WriteBuffer(buf,NumRead);
      until (NumRead = 0);
      fmem.Position:=0;
      Fsize.LoadFromStream(fmem);
      result:=ok;
   finally
      fmem.Free;
   end;
end;


procedure TForm1.FormCreate(Sender: TObject);
var s,s1:string;
    i,j:integer;
begin
   RegisterClasses([TQRsubdetail,TQRStringsBand,TQRBand,TQRGroup,TQRLabel,
         TQRDBText,TQRExpr,TQRSysData,TQRMemo,TQRRichText,
         TQRDBrichtext,TQRSHAPE,TQRIMAGE,TQRDBImage,TLabel,TEDitN]);
   for i:=0 to PageControl1.PageCount-1 do
      PageControl1.Pages[i].TabVisible:=false;
   PageControl1.ActivePageIndex:=0;
   assignfile(fromf,application.ExeName);
   FileMode := 0;  {Set file access to read only }
   reset(fromf,1);
   Fname:=tstringlist.Create;
   FHead:=tstringlist.Create;
   Fsize:=tstringlist.Create;
   if GetBodyini then
   begin
      for i:=0 to Fsize.Count-1 do
      begin
         s:=Fsize.Strings[i];
         j:=pos('|',s);
         Fname.Add(copy(s,1,j-1));
         s:=copy(s,j+1,length(s)-j);
         j:=pos('|',s);
         FHead.Add(copy(s,1,j-1));
         Fsize.Strings[i]:=copy(s,j+1,length(s)-j);
      end;
      s:='Panel1';
      if Getmem(s) then
         StringToComponent(s,Panel1);
      s:='Quickrep1';
      if Getmem(s) then
         StringToComponent(s,Quickrep1);
   end;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var i:integer;
    s,s1:string;
begin
   ADOquery1.Active:=false;
   s1:='';
   for i:=0 to Panel1.ComponentCount-1 do
   begin
      if (Panel1.Components[i] is TEditN) then
      begin
         s1:='and '+(Panel1.Components[i] as TEditN).FieldName;
         case ord((Panel1.Components[i] as TEditN).Op) of
//            ONnone:s1:=s1
//            ONSmall:
//            ONSmallEqual:
            ord(ONLikeMid):begin
                    s1:=s1+' like ';
                    s1:=s1+quotedstr('%'+(Panel1.Components[i] as TEditN).text+'%');
                 end;         
//            ONLarge:
         end;

      end;
   end;
   ADOquery1.SQL.Strings[3]:=s1;
   showmessage(ADOquery1.SQL.Text);
   ADOquery1.Active:=true;
   QuickRep1.Prepare;
   QuickRep1.PreviewModal;
end;

procedure TForm1.QuickRep1Preview(Sender: TObject);
begin
   preview.crpreview(self,sender);
end;

end.
