unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, EditN;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Button1: TButton;
    RadioGroup1: TRadioGroup;
    Function Makeexefile(var tof:file;var ini:textfile;sn,sm:string):boolean;
    Function Makeexe(ExeFileName,HeadExeFile:string):boolean;
    function ComponentToString(Component: TComponent): string;
    procedure Panel1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    numtot:integer;
    idx:integer;
  end;

var
  Form1: TForm1;


implementation
uses zlib;

{$R *.dfm}
Function TForm1.Makeexefile(var tof:file;var ini:textfile;sn,sm:string):boolean;
var  NumRead, NumWritten,Numtotf: Integer;
     Buf: array[1..2048] of Char;
     s1:string;
     cp:Tmemorystream;
     cp1:TCompressionStream;
begin
  cp:=tmemorystream.Create;
  try
     cp.Clear;
     try  //Y
        cp1:=TCompressionStream.Create(clDefault,cp);
        cp1.Write(sm[1],length(sm));
     finally
        freeandnil(cp1);
     end;
     cp.Position:=0;
     numtotf:=0;
     repeat  //[Jɧ
        NumRead:=cp.Read(buf,sizeof(buf));
        BlockWrite(ToF, Buf, NumRead, NumWritten);
        numtotf:=numtotf+NumWritten;
     until (NumRead = 0) or (NumWritten <> NumRead);
     if NumWritten <> NumRead then
        result:=false;
     s1:=sn+'|'+inttostr(numtot)+'|'+inttostr(numtotf);
     writeln(ini,s1);
     numtot:=numtot+numtotf;
  except
     freeandnil(cp);
  end;
end;

Function TForm1.Makeexe(ExeFileName,HeadExeFile:string):boolean;
var  FromF, ToF: file;
     ini:textfile;
     NumRead, NumWritten,Numtotf: Integer;
     Buf: array[1..2048] of Char;
     filerec:record
        filename:string[80];
        filesize:integer;
     end;
     ok:boolean;
     s,s1,sm,st:string;
begin
  result:=false;
  s:='';
  AssignFile(ToF, ExeFileName);	{ Open output file }
  try
     Rewrite(ToF, 1);	{ Record size = 1 }
        // Save HeadExeFile
     assignfile(fromf,HeadExeFile);
     FileMode := 0;  {Set file access to read only }
     reset(fromf,1);
     numtot:=0;
     repeat
        BlockRead(FromF, Buf, SizeOf(Buf), NumRead);
        BlockWrite(ToF, Buf, NumRead, NumWritten);
        numtot:=numtot+NumWritten;
     until (NumRead = 0) or (NumWritten <> NumRead);
     CloseFile(FromF);
     if NumWritten <> NumRead then
        ok:=false;
     s:=Extractfiledir(ExeFileName)+'\'+ExtractFileName(ExeFileName);
     s:=ChangeFileExt(s, '.ini');
//bodyβini
     assignfile(ini,s);
     rewrite(ini);                //gJbody
     Makeexefile(tof,ini,'Panel1',ComponentToString(Panel1));
//     Makeexefile(tof,ini,ComponentToString(Quickrep1));
     CloseFile(ini);
//
     assignfile(fromf,s);  //NinigJ
     FileMode := 0;  {Set file access to read only }
     reset(fromf,1);
     FileRec.filename:=extractfilename(s);
     FileRec.filesize:=0;
     repeat
        BlockRead(FromF, Buf, SizeOf(Buf), NumRead);
        BlockWrite(ToF, Buf, NumRead, NumWritten);
        FileRec.filesize:=FileRec.filesize+NumWritten;
     until (NumRead = 0) or (NumWritten <> NumRead);
     CloseFile(fromf);
     if NumWritten <> NumRead then
        ok:=false;
     // Save File Record
     BlockWrite(ToF,filerec,sizeof(filerec));
     DeleteFile(s);
  except
     result:=false;
  end;
  CloseFile(ToF);
  if messagedlg(ExeFileName+'{ͧ...O_}ҵ{',mtConfirmation, [mbYes, mbNo], 0) = mrYes then
     winexec(pchar(exefilename),SW_SHOW);
  result:=true;
end;


function TForm1.ComponentToString(Component: TComponent): string;
var
  BinStream:TMemoryStream;
  StrStream: TStringStream;
  s: string;
begin
  BinStream := TMemoryStream.Create;
  try
    StrStream := TStringStream.Create(s);
    try
      BinStream.WriteComponent(Component);
      BinStream.Seek(0, soFromBeginning);
      ObjectBinaryToText(BinStream, StrStream);
      StrStream.Seek(0, soFromBeginning);
      Result:= StrStream.DataString;
    finally
      StrStream.Free;

    end;
  finally
    BinStream.Free
  end;
end;

procedure TForm1.Panel1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   Case RadioGroup1.ItemIndex of
     0:begin
         With TLabel.Create(TComponent(Sender)) do
         begin
            Parent:=TWinControl(sender);
            Left:=x;
            Top:=y;
            name:='Label'+inttostr(idx);
            Caption:='пJs';
         end;
       end;
     1:begin
         With TEditN.Create(TComponent(Sender)) do
         begin
            Parent:=TWinControl(sender);
            Left:=x;
            Top:=y;
            name:='EditN'+inttostr(idx);
            FieldName:='Dept_no';
            op:=ONLikeMid;
            Text:='';
         end;
       end;
   end;
   idx:=idx+1;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   idx:=1;
end;

procedure TForm1.Button1Click(Sender: TObject);
var s:string;
begin
   numtot:=0;
   s:=Extractfiledir(Application.ExeName);
   Makeexe(s+'\qrtest.exe',s+'\qrexe.exe');
end;

end.
